/// <reference types="node" />
import { DefaultTasksRunnerOptions } from './default-tasks-runner';
import { Batch } from './tasks-schedule';
import { BatchResults } from './batch/batch-messages';
import { Task, TaskGraph } from '../config/task-graph';
export declare class ForkedProcessTaskRunner {
    private readonly options;
    cliPath: string;
    private readonly verbose;
    private processes;
    constructor(options: DefaultTasksRunnerOptions);
    forkProcessForBatch({ executorName, taskGraph: batchTaskGraph }: Batch, fullTaskGraph: TaskGraph, env: NodeJS.ProcessEnv): Promise<BatchResults>;
    forkProcessPipeOutputCapture(task: Task, { streamOutput, temporaryOutputPath, taskGraph, env, }: {
        streamOutput: boolean;
        temporaryOutputPath: string;
        taskGraph: TaskGraph;
        env: NodeJS.ProcessEnv;
    }): Promise<{
        code: number;
        terminalOutput: string;
    }>;
    forkProcessDirectOutputCapture(task: Task, { streamOutput, temporaryOutputPath, taskGraph, env, }: {
        streamOutput: boolean;
        temporaryOutputPath: string;
        taskGraph: TaskGraph;
        env: NodeJS.ProcessEnv;
    }): Promise<{
        code: number;
        terminalOutput: string;
    }>;
    private readTerminalOutput;
    private writeTerminalOutput;
    private signalToCode;
    private setupProcessEventListeners;
}
